# purescript-carpenter

[![purescript-carpenter on Pursuit](https://pursuit.purescript.org/packages/purescript-carpenter/badge)](https://pursuit.purescript.org/packages/purescript-carpenter)
[![Latest release](https://img.shields.io/bower/v/purescript-carpenter.svg)](https://github.com/arthur-xavier/purescript-carpenter/releases)
[![Latest release](https://img.shields.io/npm/v/purescript-carpenter.svg)](https://www.npmjs.com/package/purescript-carpenter)
[![Build Status](https://travis-ci.org/arthur-xavier/purescript-carpenter.svg?branch=master)](https://travis-ci.org/arthur-xavier/purescript-carpenter)
[![semantic-release](https://img.shields.io/badge/%20%20%F0%9F%93%A6%F0%9F%9A%80-semantic--release-e10079.svg)](https://github.com/semantic-release/semantic-release)
[![Commitizen friendly](https://img.shields.io/badge/commitizen-friendly-brightgreen.svg)](http://commitizen.github.io/cz-cli/)

Carpenter is a declarative library for type-safe state management in React applications with PureScript. Carpenter provides simple patterns and architectures for building React applications inspired by [Elm](http://elm-lang.org/), [Thermite](https://github.com/paf31/purescript-thermite) and [Halogen](https://github.com/slamdata/purescript-halogen).

- [Module Documentation](https://pursuit.purescript.org/packages/purescript-carpenter)
- [The Carpenter guide](GUIDE.md)

## Getting started

- Read [the Carpenter guide](GUIDE.md)
- Take a look at some of the examples:
  - [Counter example](examples/Counter/Counter.purs)
  - [Counter list example capturing actions](examples/CounterList/)
  - [Counter list example (Elm architecture)](examples/CounterListElm/)
  - [Writer Monad example](examples/Monad/Writer.purs)
  - [PureScript + Carpenter • TodoMVC](https://github.com/arthur-xavier/purescript-carpenter-todomvc)

## Installing

You can install Carpenter with bower:

```bash
bower install --save purescript-carpenter
```
